#!/usr/bin/env ruby

require 'tdiary'
require 'misc/plugin/pylonauth_lib'

#----------------------------------------------------------------
#
#	ǧڥ᡼(Captcha)饹
#
class Captcha

	attr_reader :image

	def initialize(oImgFiles, xImgFiles, bImgFiles, outputDir)
		@oImgFiles, @xImgFiles, @bImgFiles = oImgFiles, xImgFiles, bImgFiles
		@outputDir = outputDir
	end

	#------------------------------------------------------------
	#
	#	ǧڥ᡼
	#
	#		֥׻ɽ
	#
	#		      +0               +6          size
	#		x-1:   9 <-> 136     15 <-> 142 / 152
	#		x-2: 129 <-> 256    135 <-> 262 / 272
	#		x-3: 249 <-> 376    255 <-> 382 / 392
	#		x-n:                            n * 120 + 32
	#
	#		      +0               +6
	#		  y:   9 <-> 200     15 <-> 206 / 216
	#
	def make(right, rightcode)

		oImgs = Dir.glob(@oImgFiles)							# å
		xImgs = Dir.glob(@xImgFiles)							# å
		bImgs = Dir.glob(@bImgFiles)							# ط

		# ˹碌ƥ᡼
		x = 9; drawCmds = Array.new
		right.each_byte {|b|
			drawCmds << sprintf('-draw "image over %d,%d %d,%d \'%s\'" ', \
				x + rand(7), 9 + rand(7), 128, 192, \
				b != ?0 ? oImgs.slice!(rand(oImgs.size)) : xImgs.slice!(rand(xImgs.size))); x += 120
		}

		# CAPTCHA᡼
		convert  = "convert -size #{size = right.size * 120 + 32}x216 xc:white "
		convert += "-draw \"image over 0,0 #{size},216 '#{bImgs[rand(bImgs.size)]}'\" "
		drawCmds.sort_by { rand }.each {|cmd| convert += cmd }
		convert += (@outputDir + (@image = "captcha-#{rightcode}.jpg"))
		raise 'convert ޥɤˤ CAPTCHA ᡼˼Ԥޤ' unless(system(convert))
	end

	#------------------------------------------------------------
	#
	#	ǧڥ᡼ʲݤ
	#
	def clean(reuse)
		zImgs = Dir.glob(@outputDir + '*')
		while(zImgs.size > reuse)
			File.delete(zImgs.slice!(rand(zImgs.size)))
		end
	end

	#------------------------------------------------------------
	#
	#	ǧڥ᡼Ȥޤ魯
	#
	def reuse(checks)
		zImgs = Dir.glob(@outputDir + '*')
		raise '⤦٤֥饦Ǻɤ߹ߤ»ܤƤ' if(zImgs.size == 0)
		zImgs[rand(zImgs.size)] =~ /captcha-(.+-.+)\.jpg/
		@image = "captcha-#{rightcode = $1}.jpg"
		rightcode
	end
end

#---------------------------------------------------------------
#
#	ᥤ
#
begin

cgi = CGI.new
conf = TDiary::Config::new
pylonCRauth = PylonCRauth.new(conf['pylonauth.passphrase'])

name	= conf['pylonauth.name']	||= 'Ŵ'					# ǧ̾
checks	= conf['pylonauth.checks']	||= 5						# ǧڥ᡼Ѥǿ
least	= conf['pylonauth.least']	||= 1						# ҤȤĤϥåоݤи
renew	= conf['pylonauth.renew']	||= 10						# ǧڥ᡼򿷵Ψ(1/x)
reuse	= conf['pylonauth.reuse']	||= 100						# ǧڥ᡼ݻ
comment	= conf['pylonauth.comment'] ||= \
	"<H1>#{conf.html_title}</H1>#{name}ǧ: #{name}β֤٤ơץåǧڥܥ򲡤Ʋ"

#---------------------------------------------------------------
#
#	եΥå̤ǧ
#
challenge = ''; (1..checks).each {|n|
	challenge += (cgi["pylonauth-#{n}"] =~ /on/i ? '1' : '0')
}
if(pylonCRauth.auth_challenge(cgi['rightcode'], challenge))
	#-----------------------------------------------------------
	#
	#	ǧǧCookieURL᤹
	#
	otarget = (it = cgi['otarget'] and cgi['otarget'] != '') ? "http://#{it}" : conf.base_url
	print <<SUCCESS
Content-Type: text/html; charset=EUC-JP
Set-Cookie: pylonauth=#{pylonCRauth.get_challenge}
Location: #{otarget}

<HTML>
<HEAD>
	<TITLE>#{name}ǧ</TITLE>
</HEAD>
<BODY>
	<A href='#{otarget}'>#{name}ǧ</A>
</BODY>
</HTML>
SUCCESS

else
	#-----------------------------------------------------------
	#
	#	̤ǧڡǧڼԡǧڥ᡼Ѱդ
	#
	sourceDir = "#{conf.data_path}cache/pylonauth/"
	outputDir = 'images/pylonauth/'
	captcha = Captcha.new(
		"#{sourceDir}img_on/*",									# å
		"#{sourceDir}img_off/*",								# å
		"#{sourceDir}img_bg/*",									# ط
		outputDir)												# ϥǥ쥯ȥ
	if(rand(renew) == 0)
		right = sprintf('%0*b', checks, rand(2 ** checks - least) + least)	# 
		rightcode = pylonCRauth.get_challenge(right)
		captcha.clean(reuse - 1)
		captcha.make(right, rightcode)
	else
		rightcode = captcha.reuse('*' * checks)					# ¸ʪȤޤ魯
	end

	#-----------------------------------------------------------
	#
	#	ǧڥե
	#
	tabledebug = '' # + " border = '1'"

	imgHtml = "<IMG src='#{outputDir}#{captcha.image}' height='216'>"

	checkHtml = ''; (1..checks).each {|n|
		checkHtml += "\n\t\t<TD><INPUT type='checkbox' name='pylonauth-#{n}' id='c#{n}'>"
		checkHtml += "<BR><LABEL for='c#{n}'>Check!!</LABEL>"
	}

	print <<AUTHFORM
Content-Type: text/html; charset=EUC-JP

<HTML>
<HEAD>
	<META http-equiv='Content-Type' content='text/html; charset=EUC-JP'>
	<META name='generator' content='pylonauth.rb $Revision: 1.3 $'>
	<TITLE>#{name}ǧ</TITLE>
</HEAD>
<BODY>
	<FORM method='post' action='pylonauth.rb'>
	<TABLE#{tabledebug}>
		<INPUT type='hidden' name='rightcode' value='#{rightcode}'>
		<INPUT type='hidden' name='otarget' value='#{cgi['otarget']}'>

	<TR align='center'>
		<TD colspan='#{checks + 2}'>#{comment}

	<TR align='center'>
		<TD width='50%'>
		<TD colspan='#{checks}'>#{imgHtml}
		<TD width='50%'>

	<TR align='center'>
		<TD width='50%'>#{checkHtml}
		<TD width='50%'>

	<TR align='center'>
		<TD width='50%'>
		<TD colspan='#{checks}'><BR><INPUT type='submit' name='submit' value='ǧڡ'>
		<TD width='50%'>
	</TABLE>
	</FORM>
</BODY>
</HTML>
AUTHFORM

end

rescue
	print <<EXCEPTION
Content-Type: text/html; charset=EUC-JP

===== EXCEPTION: #{$!} =====<BR>
#{$@.join("<BR>\n")}
EXCEPTION
end

__END__

